/*******************************************************************************
 * Copyright (c) 2010 Attila Kovacs <attila_kovacs@post.harvard.edu>.
 * All rights reserved. 
 * 
 * This file is part of crush.
 * 
 *     crush is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 * 
 *     crush is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with crush.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Contributors:
 *     Attila Kovacs <attila_kovacs@post.harvard.edu> - initial API and implementation
 ******************************************************************************/
// Copyright (c) 2009 Attila Kovacs 

package crush.apex;

import util.Unit;
import crush.*;


public class APEXFrame extends HorizontalFrame {
	public int chopperPhase;
	boolean isValid = true;
	
	public static double skydipFactor = 1.0;
	
	public APEXFrame(APEXArrayScan<?, ?> parent) {
		super(parent);
	}

	@Override
	public void setZenithTau(double value) {
		super.setZenithTau(skydipFactor * value);
	}
	
	public boolean isValid() {	
		if(Double.isNaN(equatorial.x)) return false;
		else if(Double.isNaN(equatorial.y)) return false;
		else if(Double.isNaN(horizontal.x)) return false;
		else if(Double.isNaN(horizontal.y)) return false;
		else if(horizontalOffset.x < -900.0*Unit.deg) return false;
		else if(horizontalOffset.y < -900.0*Unit.deg) return false;		
		return true;
	}
	
	public void parse(float[][] fitsData) {
		data = new float[fitsData.length];
		for(int c=0; c<fitsData.length; c++) data[c] = fitsData[c][0];		
	}
	
	public void parse(float[] flatData, int fromIndex, int toIndex) {
		data = new float[toIndex - fromIndex];
		for(int c=0; c<data.length; c++) data[c] = flatData[fromIndex + c];		
	}
}
